#ifndef TARGET_H_
#define TARGET_H_

#define CCLK       100000000
#define PCLK       100000000
#define PLL0_MVAL  25 // 300MHz/3
#define PLL0_NVAL   2
#define CCLK_DIV    3

#define CCLK_1   0b01
#define CCLK_2   0b10
#define CCLK_4   0b00
#define CCLK_8   0b11

#define PCLK_WDT_DIV      CCLK_1
#define PCLK_TIMER0_DIV   CCLK_1
#define PCLK_TIMER1_DIV   CCLK_1
#define PCLK_UART0_DIV    CCLK_1
#define PCLK_UART1_DIV    CCLK_1
#define PCLK_PWM1_DIV     CCLK_1
#define PCLK_I2C0_DIV     CCLK_1
#define PCLK_SPI_DIV      CCLK_1
#define PCLK_SSP1_DIV     CCLK_1
#define PCLK_DAC_DIV      CCLK_1
#define PCLK_ADC_DIV      CCLK_1
#define PCLK_CAN_DIV      CCLK_1
#define PCLK_ACF_DIV      CCLK_1

#define PCLK_QEI_DIV      CCLK_1
#define PCLK_GPIOINT_DIV  CCLK_1
#define PCLK_PCB_DIV      CCLK_1
#define PCLK_I2C1_DIV     CCLK_1
#define PCLK_SSP0_DIV     CCLK_1
#define PCLK_TIMER2_DIV   CCLK_1
#define PCLK_TIMER3_DIV   CCLK_1
#define PCLK_UART2_DIV    CCLK_1
#define PCLK_UART3_DIV    CCLK_1
#define PCLK_I2C2_DIV     CCLK_1
#define PCLK_I2S_DIV      CCLK_1
#define PCLK_RIT_DIV      CCLK_1
#define PCLK_SYSCON_DIV   CCLK_1
#define PCLK_MC_DIV       CCLK_1

#define PCLK_SPEED(x) ((x==0b01)?PCLK:((x==0b10)?PCLK/2:((x==0b00)?PCLK/4:PCLK/8)))

#define PCLK_WDT          PCLK_SPEED(PCLK_WDT_DIV)
#define PCLK_TIMER0       PCLK_SPEED(PCLK_TIMER0_DIV)
#define PCLK_TIMER1       PCLK_SPEED(PCLK_TIMER1_DIV)
#define PCLK_UART0        PCLK_SPEED(PCLK_UART0_DIV)
#define PCLK_UART1        PCLK_SPEED(PCLK_UART1_DIV)
#define PCLK_PWM1         PCLK_SPEED(PCLK_PWM1_DIV)
#define PCLK_I2C0         PCLK_SPEED(PCLK_I2C0_DIV)
#define PCLK_SPI          PCLK_SPEED(PCLK_SPI_DIV)
#define PCLK_SSP1         PCLK_SPEED(PCLK_SSP1_DIV)
#define PCLK_DAC          PCLK_SPEED(PCLK_DAC_DIV)
#define PCLK_ADC          PCLK_SPEED(PCLK_ADC_DIV)
#define PCLK_CAN          PCLK_SPEED(PCLK_CAN_DIV)
#define PCLK_ACF          PCLK_SPEED(PCLK_ACF_DIV)

#define PCLK_QEI          PCLK_SPEED(PCLK_QEI_DIV)
#define PCLK_GPIOINT      PCLK_SPEED(PCLK_GPIOINT_DIV)
#define PCLK_PCB          PCLK_SPEED(PCLK_PCB_DIV)
#define PCLK_I2C1         PCLK_SPEED(PCLK_I2C1_DIV)
#define PCLK_SSP0         PCLK_SPEED(PCLK_SSP0_DIV)
#define PCLK_TIMER2       PCLK_SPEED(PCLK_TIMER2_DIV)
#define PCLK_TIMER3       PCLK_SPEED(PCLK_TIMER3_DIV)
#define PCLK_UART2        PCLK_SPEED(PCLK_UART2_DIV)
#define PCLK_UART3        PCLK_SPEED(PCLK_UART3_DIV)
#define PCLK_I2C2         PCLK_SPEED(PCLK_I2C2_DIV)
#define PCLK_I2S          PCLK_SPEED(PCLK_I2S_DIV)
#define PCLK_RIT          PCLK_SPEED(PCLK_RIT)
#define PCLK_SYSCON       PCLK_SPEED(PCLK_SYSCON_DIV)
#define PCLK_MC           PCLK_SPEED(PCLK_MS_DIV)

#define PCLKSEL0_Val  (PCLK_WDT_DIV << 0)     | \
					  (PCLK_TIMER0_DIV << 2)  | \
					  (PCLK_TIMER1_DIV << 4)  | \
					  (PCLK_UART0_DIV << 6)   | \
					  (PCLK_UART1_DIV << 8)   | \
					  (PCLK_PWM1_DIV << 12)   | \
					  (PCLK_I2C0_DIV << 14)   | \
					  (PCLK_SPI_DIV << 16)    | \
					  (PCLK_SSP1_DIV << 20)   | \
					  (PCLK_DAC_DIV << 22)    | \
					  (PCLK_ADC_DIV << 24)    | \
					  (PCLK_CAN_DIV << 26)    | \
					  (PCLK_CAN_DIV << 28)    | \
					  (PCLK_ACF_DIV << 30)

#define PCLKSEL1_Val  (PCLK_QEI_DIV << 0)     | \
	                  (PCLK_GPIOINT_DIV << 2) | \
	                  (PCLK_PCB_DIV << 4)     | \
	                  (PCLK_I2C1_DIV << 6)    | \
	                  (PCLK_SSP0_DIV << 10)   | \
	                  (PCLK_TIMER2_DIV << 12) | \
	                  (PCLK_TIMER3_DIV << 14) | \
	                  (PCLK_UART2_DIV << 16)  | \
	                  (PCLK_UART3_DIV << 18)  | \
	                  (PCLK_I2C2_DIV << 20)   | \
	                  (PCLK_I2S_DIV << 22)    | \
	                  (PCLK_RIT_DIV << 26)    | \
	                  (PCLK_SYSCON_DIV << 28) | \
	                  (PCLK_MC_DIV << 30)

#endif /* TARGET_H_ */
